<?php

namespace JReviewsDeploy\Administrator\View\Jreviewsdeploy;

use Joomla\CMS\Factory;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use JReviewsDeploy\Administrator\Services\AppStoreService;

defined('_JEXEC') or die;

class HtmlView extends BaseHtmlView
{
    protected $content;

    protected $errors = [];
    
    protected $service;

    protected $installed;

    protected $app;


    public function __construct(...$params)
    {
        parent::__construct(...$params);

        $this->service = new AppStoreService();
    }

    public function logError(string $message)
    {
        $this->errors[] = $message;
    }

    public function setContent($content)
    {
        $this->content = $content;
    }

    protected function getContent()
    {
        return $this->content;
    }

    protected function errors()
    {
        return $this->errors;
    }

    protected function products()
    {
        return $this->service->installedProducts();
    }

    public function setInstalled($name)
    {
        return $this->installed = $name;
    }

    protected function installed()
    {
        return $this->installed;
    }

    protected function getLicenseNumber()
    {
        return \JReviewsDeploy\jr_license();
    }

    protected function endpoint($task)
    {
        return "index.php?option=com_jreviewsdeploy&task=$task&format=raw";
    }

    protected function loadingUrl()
    {
        return Uri::base().'/components/com_jreviewsdeploy/tmpl/jreviewsdeploy/loading.svg';
    }

    protected function thereAreProductsWithAvailableUpdates()
    {
        $products = $this->service->installedProducts();

        $updatable = array_filter($products, function($product) {
            if ($product['new']) {
                return true;
            }

            return false;
        });

        return count($updatable) > 0;
    }

    protected function disabledAddons()
    {
        $db = Factory::getContainer()->get('DatabaseDriver');

		$query = $db->getQuery(true)
			->select('name')
			->from($db->quoteName('#__jreviews_addons'))
			->where($db->quoteName('state') . ' = 0');

		return $db->setQuery($query)->loadColumn();
    }
}
